module Iso3166 exposing (CountryCode(..),toAlpha2,fromAlpha2,toAlpha3,fromAlpha3,toNumeric,fromNumeric,all)

-- Generated by 'generate/Main.hs' do not edit by hand

{-| Convert to and from Iso3166 country codes.
@docs toAlpha2
@docs fromAlpha2
@docs toAlpha3
@docs fromAlpha3
@docs toNumeric
@docs fromNumeric
@docs all
# Definition
@docs CountryCode
-}

{-| `GT` and `LT` are defined in `Basics` so we define them as `GT_` and `LT_`.
-}
type CountryCode
    = AD
    | AE
    | AF
    | AG
    | AI
    | AL
    | AM
    | AO
    | AQ
    | AR
    | AS
    | AT
    | AU
    | AW
    | AX
    | AZ
    | BA
    | BB
    | BD
    | BE
    | BF
    | BG
    | BH
    | BI
    | BJ
    | BL
    | BM
    | BN
    | BO
    | BQ
    | BR
    | BS
    | BT
    | BV
    | BW
    | BY
    | BZ
    | CA
    | CC
    | CD
    | CF
    | CG
    | CH
    | CI
    | CK
    | CL
    | CM
    | CN
    | CO
    | CR
    | CU
    | CV
    | CW
    | CX
    | CY
    | CZ
    | DE
    | DJ
    | DK
    | DM
    | DO
    | DZ
    | EC
    | EE
    | EG
    | EH
    | ER
    | ES
    | ET
    | FI
    | FJ
    | FK
    | FM
    | FO
    | FR
    | GA
    | GB
    | GD
    | GE
    | GF
    | GG
    | GH
    | GI
    | GL
    | GM
    | GN
    | GP
    | GQ
    | GR
    | GS
    | GT_
    | GU
    | GW
    | GY
    | HK
    | HM
    | HN
    | HR
    | HT
    | HU
    | ID
    | IE
    | IL
    | IM
    | IN
    | IO
    | IQ
    | IR
    | IS
    | IT
    | JE
    | JM
    | JO
    | JP
    | KE
    | KG
    | KH
    | KI
    | KM
    | KN
    | KP
    | KR
    | KW
    | KY
    | KZ
    | LA
    | LB
    | LC
    | LI
    | LK
    | LR
    | LS
    | LT_
    | LU
    | LV
    | LY
    | MA
    | MC
    | MD
    | ME
    | MF
    | MG
    | MH
    | MK
    | ML
    | MM
    | MN
    | MO
    | MP
    | MQ
    | MR
    | MS
    | MT
    | MU
    | MV
    | MW
    | MX
    | MY
    | MZ
    | NA
    | NC
    | NE
    | NF
    | NG
    | NI
    | NL
    | NO
    | NP
    | NR
    | NU
    | NZ
    | OM
    | PA
    | PE
    | PF
    | PG
    | PH
    | PK
    | PL
    | PM
    | PN
    | PR
    | PS
    | PT
    | PW
    | PY
    | QA
    | RE
    | RO
    | RS
    | RU
    | RW
    | SA
    | SB
    | SC
    | SD
    | SE
    | SG
    | SH
    | SI
    | SJ
    | SK
    | SL
    | SM
    | SN
    | SO
    | SR
    | SS
    | ST
    | SV
    | SX
    | SY
    | SZ
    | TC
    | TD
    | TF
    | TG
    | TH
    | TJ
    | TK
    | TL
    | TM
    | TN
    | TO
    | TR
    | TT
    | TV
    | TW
    | TZ
    | UA
    | UG
    | UM
    | US
    | UY
    | UZ
    | VA
    | VC
    | VE
    | VG
    | VI
    | VN
    | VU
    | WF
    | WS
    | YE
    | YT
    | ZA
    | ZM
    | ZW

{-| Two-letter `ISO 3166-1 alpha-2` code from `CountryCode`.
-}
toAlpha2 : CountryCode -> String
toAlpha2 c =
    case c of
        AD -> "ad"
        AE -> "ae"
        AF -> "af"
        AG -> "ag"
        AI -> "ai"
        AL -> "al"
        AM -> "am"
        AO -> "ao"
        AQ -> "aq"
        AR -> "ar"
        AS -> "as"
        AT -> "at"
        AU -> "au"
        AW -> "aw"
        AX -> "ax"
        AZ -> "az"
        BA -> "ba"
        BB -> "bb"
        BD -> "bd"
        BE -> "be"
        BF -> "bf"
        BG -> "bg"
        BH -> "bh"
        BI -> "bi"
        BJ -> "bj"
        BL -> "bl"
        BM -> "bm"
        BN -> "bn"
        BO -> "bo"
        BQ -> "bq"
        BR -> "br"
        BS -> "bs"
        BT -> "bt"
        BV -> "bv"
        BW -> "bw"
        BY -> "by"
        BZ -> "bz"
        CA -> "ca"
        CC -> "cc"
        CD -> "cd"
        CF -> "cf"
        CG -> "cg"
        CH -> "ch"
        CI -> "ci"
        CK -> "ck"
        CL -> "cl"
        CM -> "cm"
        CN -> "cn"
        CO -> "co"
        CR -> "cr"
        CU -> "cu"
        CV -> "cv"
        CW -> "cw"
        CX -> "cx"
        CY -> "cy"
        CZ -> "cz"
        DE -> "de"
        DJ -> "dj"
        DK -> "dk"
        DM -> "dm"
        DO -> "do"
        DZ -> "dz"
        EC -> "ec"
        EE -> "ee"
        EG -> "eg"
        EH -> "eh"
        ER -> "er"
        ES -> "es"
        ET -> "et"
        FI -> "fi"
        FJ -> "fj"
        FK -> "fk"
        FM -> "fm"
        FO -> "fo"
        FR -> "fr"
        GA -> "ga"
        GB -> "gb"
        GD -> "gd"
        GE -> "ge"
        GF -> "gf"
        GG -> "gg"
        GH -> "gh"
        GI -> "gi"
        GL -> "gl"
        GM -> "gm"
        GN -> "gn"
        GP -> "gp"
        GQ -> "gq"
        GR -> "gr"
        GS -> "gs"
        GT_ -> "gt"
        GU -> "gu"
        GW -> "gw"
        GY -> "gy"
        HK -> "hk"
        HM -> "hm"
        HN -> "hn"
        HR -> "hr"
        HT -> "ht"
        HU -> "hu"
        ID -> "id"
        IE -> "ie"
        IL -> "il"
        IM -> "im"
        IN -> "in"
        IO -> "io"
        IQ -> "iq"
        IR -> "ir"
        IS -> "is"
        IT -> "it"
        JE -> "je"
        JM -> "jm"
        JO -> "jo"
        JP -> "jp"
        KE -> "ke"
        KG -> "kg"
        KH -> "kh"
        KI -> "ki"
        KM -> "km"
        KN -> "kn"
        KP -> "kp"
        KR -> "kr"
        KW -> "kw"
        KY -> "ky"
        KZ -> "kz"
        LA -> "la"
        LB -> "lb"
        LC -> "lc"
        LI -> "li"
        LK -> "lk"
        LR -> "lr"
        LS -> "ls"
        LT_ -> "lt"
        LU -> "lu"
        LV -> "lv"
        LY -> "ly"
        MA -> "ma"
        MC -> "mc"
        MD -> "md"
        ME -> "me"
        MF -> "mf"
        MG -> "mg"
        MH -> "mh"
        MK -> "mk"
        ML -> "ml"
        MM -> "mm"
        MN -> "mn"
        MO -> "mo"
        MP -> "mp"
        MQ -> "mq"
        MR -> "mr"
        MS -> "ms"
        MT -> "mt"
        MU -> "mu"
        MV -> "mv"
        MW -> "mw"
        MX -> "mx"
        MY -> "my"
        MZ -> "mz"
        NA -> "na"
        NC -> "nc"
        NE -> "ne"
        NF -> "nf"
        NG -> "ng"
        NI -> "ni"
        NL -> "nl"
        NO -> "no"
        NP -> "np"
        NR -> "nr"
        NU -> "nu"
        NZ -> "nz"
        OM -> "om"
        PA -> "pa"
        PE -> "pe"
        PF -> "pf"
        PG -> "pg"
        PH -> "ph"
        PK -> "pk"
        PL -> "pl"
        PM -> "pm"
        PN -> "pn"
        PR -> "pr"
        PS -> "ps"
        PT -> "pt"
        PW -> "pw"
        PY -> "py"
        QA -> "qa"
        RE -> "re"
        RO -> "ro"
        RS -> "rs"
        RU -> "ru"
        RW -> "rw"
        SA -> "sa"
        SB -> "sb"
        SC -> "sc"
        SD -> "sd"
        SE -> "se"
        SG -> "sg"
        SH -> "sh"
        SI -> "si"
        SJ -> "sj"
        SK -> "sk"
        SL -> "sl"
        SM -> "sm"
        SN -> "sn"
        SO -> "so"
        SR -> "sr"
        SS -> "ss"
        ST -> "st"
        SV -> "sv"
        SX -> "sx"
        SY -> "sy"
        SZ -> "sz"
        TC -> "tc"
        TD -> "td"
        TF -> "tf"
        TG -> "tg"
        TH -> "th"
        TJ -> "tj"
        TK -> "tk"
        TL -> "tl"
        TM -> "tm"
        TN -> "tn"
        TO -> "to"
        TR -> "tr"
        TT -> "tt"
        TV -> "tv"
        TW -> "tw"
        TZ -> "tz"
        UA -> "ua"
        UG -> "ug"
        UM -> "um"
        US -> "us"
        UY -> "uy"
        UZ -> "uz"
        VA -> "va"
        VC -> "vc"
        VE -> "ve"
        VG -> "vg"
        VI -> "vi"
        VN -> "vn"
        VU -> "vu"
        WF -> "wf"
        WS -> "ws"
        YE -> "ye"
        YT -> "yt"
        ZA -> "za"
        ZM -> "zm"
        ZW -> "zw"

{-| `CountryCode` from two-letter `ISO 3166-1 alpha-2` code.
-}
fromAlpha2 : String -> Maybe CountryCode
fromAlpha2 s =
    case s of
        "ad" -> Just AD
        "ae" -> Just AE
        "af" -> Just AF
        "ag" -> Just AG
        "ai" -> Just AI
        "al" -> Just AL
        "am" -> Just AM
        "ao" -> Just AO
        "aq" -> Just AQ
        "ar" -> Just AR
        "as" -> Just AS
        "at" -> Just AT
        "au" -> Just AU
        "aw" -> Just AW
        "ax" -> Just AX
        "az" -> Just AZ
        "ba" -> Just BA
        "bb" -> Just BB
        "bd" -> Just BD
        "be" -> Just BE
        "bf" -> Just BF
        "bg" -> Just BG
        "bh" -> Just BH
        "bi" -> Just BI
        "bj" -> Just BJ
        "bl" -> Just BL
        "bm" -> Just BM
        "bn" -> Just BN
        "bo" -> Just BO
        "bq" -> Just BQ
        "br" -> Just BR
        "bs" -> Just BS
        "bt" -> Just BT
        "bv" -> Just BV
        "bw" -> Just BW
        "by" -> Just BY
        "bz" -> Just BZ
        "ca" -> Just CA
        "cc" -> Just CC
        "cd" -> Just CD
        "cf" -> Just CF
        "cg" -> Just CG
        "ch" -> Just CH
        "ci" -> Just CI
        "ck" -> Just CK
        "cl" -> Just CL
        "cm" -> Just CM
        "cn" -> Just CN
        "co" -> Just CO
        "cr" -> Just CR
        "cu" -> Just CU
        "cv" -> Just CV
        "cw" -> Just CW
        "cx" -> Just CX
        "cy" -> Just CY
        "cz" -> Just CZ
        "de" -> Just DE
        "dj" -> Just DJ
        "dk" -> Just DK
        "dm" -> Just DM
        "do" -> Just DO
        "dz" -> Just DZ
        "ec" -> Just EC
        "ee" -> Just EE
        "eg" -> Just EG
        "eh" -> Just EH
        "er" -> Just ER
        "es" -> Just ES
        "et" -> Just ET
        "fi" -> Just FI
        "fj" -> Just FJ
        "fk" -> Just FK
        "fm" -> Just FM
        "fo" -> Just FO
        "fr" -> Just FR
        "ga" -> Just GA
        "gb" -> Just GB
        "gd" -> Just GD
        "ge" -> Just GE
        "gf" -> Just GF
        "gg" -> Just GG
        "gh" -> Just GH
        "gi" -> Just GI
        "gl" -> Just GL
        "gm" -> Just GM
        "gn" -> Just GN
        "gp" -> Just GP
        "gq" -> Just GQ
        "gr" -> Just GR
        "gs" -> Just GS
        "gt" -> Just GT_
        "gu" -> Just GU
        "gw" -> Just GW
        "gy" -> Just GY
        "hk" -> Just HK
        "hm" -> Just HM
        "hn" -> Just HN
        "hr" -> Just HR
        "ht" -> Just HT
        "hu" -> Just HU
        "id" -> Just ID
        "ie" -> Just IE
        "il" -> Just IL
        "im" -> Just IM
        "in" -> Just IN
        "io" -> Just IO
        "iq" -> Just IQ
        "ir" -> Just IR
        "is" -> Just IS
        "it" -> Just IT
        "je" -> Just JE
        "jm" -> Just JM
        "jo" -> Just JO
        "jp" -> Just JP
        "ke" -> Just KE
        "kg" -> Just KG
        "kh" -> Just KH
        "ki" -> Just KI
        "km" -> Just KM
        "kn" -> Just KN
        "kp" -> Just KP
        "kr" -> Just KR
        "kw" -> Just KW
        "ky" -> Just KY
        "kz" -> Just KZ
        "la" -> Just LA
        "lb" -> Just LB
        "lc" -> Just LC
        "li" -> Just LI
        "lk" -> Just LK
        "lr" -> Just LR
        "ls" -> Just LS
        "lt" -> Just LT_
        "lu" -> Just LU
        "lv" -> Just LV
        "ly" -> Just LY
        "ma" -> Just MA
        "mc" -> Just MC
        "md" -> Just MD
        "me" -> Just ME
        "mf" -> Just MF
        "mg" -> Just MG
        "mh" -> Just MH
        "mk" -> Just MK
        "ml" -> Just ML
        "mm" -> Just MM
        "mn" -> Just MN
        "mo" -> Just MO
        "mp" -> Just MP
        "mq" -> Just MQ
        "mr" -> Just MR
        "ms" -> Just MS
        "mt" -> Just MT
        "mu" -> Just MU
        "mv" -> Just MV
        "mw" -> Just MW
        "mx" -> Just MX
        "my" -> Just MY
        "mz" -> Just MZ
        "na" -> Just NA
        "nc" -> Just NC
        "ne" -> Just NE
        "nf" -> Just NF
        "ng" -> Just NG
        "ni" -> Just NI
        "nl" -> Just NL
        "no" -> Just NO
        "np" -> Just NP
        "nr" -> Just NR
        "nu" -> Just NU
        "nz" -> Just NZ
        "om" -> Just OM
        "pa" -> Just PA
        "pe" -> Just PE
        "pf" -> Just PF
        "pg" -> Just PG
        "ph" -> Just PH
        "pk" -> Just PK
        "pl" -> Just PL
        "pm" -> Just PM
        "pn" -> Just PN
        "pr" -> Just PR
        "ps" -> Just PS
        "pt" -> Just PT
        "pw" -> Just PW
        "py" -> Just PY
        "qa" -> Just QA
        "re" -> Just RE
        "ro" -> Just RO
        "rs" -> Just RS
        "ru" -> Just RU
        "rw" -> Just RW
        "sa" -> Just SA
        "sb" -> Just SB
        "sc" -> Just SC
        "sd" -> Just SD
        "se" -> Just SE
        "sg" -> Just SG
        "sh" -> Just SH
        "si" -> Just SI
        "sj" -> Just SJ
        "sk" -> Just SK
        "sl" -> Just SL
        "sm" -> Just SM
        "sn" -> Just SN
        "so" -> Just SO
        "sr" -> Just SR
        "ss" -> Just SS
        "st" -> Just ST
        "sv" -> Just SV
        "sx" -> Just SX
        "sy" -> Just SY
        "sz" -> Just SZ
        "tc" -> Just TC
        "td" -> Just TD
        "tf" -> Just TF
        "tg" -> Just TG
        "th" -> Just TH
        "tj" -> Just TJ
        "tk" -> Just TK
        "tl" -> Just TL
        "tm" -> Just TM
        "tn" -> Just TN
        "to" -> Just TO
        "tr" -> Just TR
        "tt" -> Just TT
        "tv" -> Just TV
        "tw" -> Just TW
        "tz" -> Just TZ
        "ua" -> Just UA
        "ug" -> Just UG
        "um" -> Just UM
        "us" -> Just US
        "uy" -> Just UY
        "uz" -> Just UZ
        "va" -> Just VA
        "vc" -> Just VC
        "ve" -> Just VE
        "vg" -> Just VG
        "vi" -> Just VI
        "vn" -> Just VN
        "vu" -> Just VU
        "wf" -> Just WF
        "ws" -> Just WS
        "ye" -> Just YE
        "yt" -> Just YT
        "za" -> Just ZA
        "zm" -> Just ZM
        "zw" -> Just ZW
        _ -> Nothing

{-| Three-letter `ISO 3166-1 alpha-3` code from `CountryCode`.
-}
toAlpha3 : CountryCode -> String
toAlpha3 c =
    case c of
        AD -> "and"
        AE -> "are"
        AF -> "afg"
        AG -> "atg"
        AI -> "aia"
        AL -> "alb"
        AM -> "arm"
        AO -> "ago"
        AQ -> "ata"
        AR -> "arg"
        AS -> "asm"
        AT -> "aut"
        AU -> "aus"
        AW -> "abw"
        AX -> "ala"
        AZ -> "aze"
        BA -> "bih"
        BB -> "brb"
        BD -> "bgd"
        BE -> "bel"
        BF -> "bfa"
        BG -> "bgr"
        BH -> "bhr"
        BI -> "bdi"
        BJ -> "ben"
        BL -> "blm"
        BM -> "bmu"
        BN -> "brn"
        BO -> "bol"
        BQ -> "bes"
        BR -> "bra"
        BS -> "bhs"
        BT -> "btn"
        BV -> "bvt"
        BW -> "bwa"
        BY -> "blr"
        BZ -> "blz"
        CA -> "can"
        CC -> "cck"
        CD -> "cod"
        CF -> "caf"
        CG -> "cog"
        CH -> "che"
        CI -> "civ"
        CK -> "cok"
        CL -> "chl"
        CM -> "cmr"
        CN -> "chn"
        CO -> "col"
        CR -> "cri"
        CU -> "cub"
        CV -> "cpv"
        CW -> "cuw"
        CX -> "cxr"
        CY -> "cyp"
        CZ -> "cze"
        DE -> "deu"
        DJ -> "dji"
        DK -> "dnk"
        DM -> "dma"
        DO -> "dom"
        DZ -> "dza"
        EC -> "ecu"
        EE -> "est"
        EG -> "egy"
        EH -> "esh"
        ER -> "eri"
        ES -> "esp"
        ET -> "eth"
        FI -> "fin"
        FJ -> "fji"
        FK -> "flk"
        FM -> "fsm"
        FO -> "fro"
        FR -> "fra"
        GA -> "gab"
        GB -> "gbr"
        GD -> "grd"
        GE -> "geo"
        GF -> "guf"
        GG -> "ggy"
        GH -> "gha"
        GI -> "gib"
        GL -> "grl"
        GM -> "gmb"
        GN -> "gin"
        GP -> "glp"
        GQ -> "gnq"
        GR -> "grc"
        GS -> "sgs"
        GT_ -> "gtm"
        GU -> "gum"
        GW -> "gnb"
        GY -> "guy"
        HK -> "hkg"
        HM -> "hmd"
        HN -> "hnd"
        HR -> "hrv"
        HT -> "hti"
        HU -> "hun"
        ID -> "idn"
        IE -> "irl"
        IL -> "isr"
        IM -> "imn"
        IN -> "ind"
        IO -> "iot"
        IQ -> "irq"
        IR -> "irn"
        IS -> "isl"
        IT -> "ita"
        JE -> "jey"
        JM -> "jam"
        JO -> "jor"
        JP -> "jpn"
        KE -> "ken"
        KG -> "kgz"
        KH -> "khm"
        KI -> "kir"
        KM -> "com"
        KN -> "kna"
        KP -> "prk"
        KR -> "kor"
        KW -> "kwt"
        KY -> "cym"
        KZ -> "kaz"
        LA -> "lao"
        LB -> "lbn"
        LC -> "lca"
        LI -> "lie"
        LK -> "lka"
        LR -> "lbr"
        LS -> "lso"
        LT_ -> "ltu"
        LU -> "lux"
        LV -> "lva"
        LY -> "lby"
        MA -> "mar"
        MC -> "mco"
        MD -> "mda"
        ME -> "mne"
        MF -> "maf"
        MG -> "mdg"
        MH -> "mhl"
        MK -> "mkd"
        ML -> "mli"
        MM -> "mmr"
        MN -> "mng"
        MO -> "mac"
        MP -> "mnp"
        MQ -> "mtq"
        MR -> "mrt"
        MS -> "msr"
        MT -> "mlt"
        MU -> "mus"
        MV -> "mdv"
        MW -> "mwi"
        MX -> "mex"
        MY -> "mys"
        MZ -> "moz"
        NA -> "nam"
        NC -> "ncl"
        NE -> "ner"
        NF -> "nfk"
        NG -> "nga"
        NI -> "nic"
        NL -> "nld"
        NO -> "nor"
        NP -> "npl"
        NR -> "nru"
        NU -> "niu"
        NZ -> "nzl"
        OM -> "omn"
        PA -> "pan"
        PE -> "per"
        PF -> "pyf"
        PG -> "png"
        PH -> "phl"
        PK -> "pak"
        PL -> "pol"
        PM -> "spm"
        PN -> "pcn"
        PR -> "pri"
        PS -> "pse"
        PT -> "prt"
        PW -> "plw"
        PY -> "pry"
        QA -> "qat"
        RE -> "reu"
        RO -> "rou"
        RS -> "srb"
        RU -> "rus"
        RW -> "rwa"
        SA -> "sau"
        SB -> "slb"
        SC -> "syc"
        SD -> "sdn"
        SE -> "swe"
        SG -> "sgp"
        SH -> "shn"
        SI -> "svn"
        SJ -> "sjm"
        SK -> "svk"
        SL -> "sle"
        SM -> "smr"
        SN -> "sen"
        SO -> "som"
        SR -> "sur"
        SS -> "ssd"
        ST -> "stp"
        SV -> "slv"
        SX -> "sxm"
        SY -> "syr"
        SZ -> "swz"
        TC -> "tca"
        TD -> "tcd"
        TF -> "atf"
        TG -> "tgo"
        TH -> "tha"
        TJ -> "tjk"
        TK -> "tkl"
        TL -> "tls"
        TM -> "tkm"
        TN -> "tun"
        TO -> "ton"
        TR -> "tur"
        TT -> "tto"
        TV -> "tuv"
        TW -> "twn"
        TZ -> "tza"
        UA -> "ukr"
        UG -> "uga"
        UM -> "umi"
        US -> "usa"
        UY -> "ury"
        UZ -> "uzb"
        VA -> "vat"
        VC -> "vct"
        VE -> "ven"
        VG -> "vgb"
        VI -> "vir"
        VN -> "vnm"
        VU -> "vut"
        WF -> "wlf"
        WS -> "wsm"
        YE -> "yem"
        YT -> "myt"
        ZA -> "zaf"
        ZM -> "zmb"
        ZW -> "zwe"

{-| `CountryCode` from three-letter `ISO 3166-1 alpha-3` code.
-}
fromAlpha3 : String -> Maybe CountryCode
fromAlpha3 s =
    case s of
        "and" -> Just AD
        "are" -> Just AE
        "afg" -> Just AF
        "atg" -> Just AG
        "aia" -> Just AI
        "alb" -> Just AL
        "arm" -> Just AM
        "ago" -> Just AO
        "ata" -> Just AQ
        "arg" -> Just AR
        "asm" -> Just AS
        "aut" -> Just AT
        "aus" -> Just AU
        "abw" -> Just AW
        "ala" -> Just AX
        "aze" -> Just AZ
        "bih" -> Just BA
        "brb" -> Just BB
        "bgd" -> Just BD
        "bel" -> Just BE
        "bfa" -> Just BF
        "bgr" -> Just BG
        "bhr" -> Just BH
        "bdi" -> Just BI
        "ben" -> Just BJ
        "blm" -> Just BL
        "bmu" -> Just BM
        "brn" -> Just BN
        "bol" -> Just BO
        "bes" -> Just BQ
        "bra" -> Just BR
        "bhs" -> Just BS
        "btn" -> Just BT
        "bvt" -> Just BV
        "bwa" -> Just BW
        "blr" -> Just BY
        "blz" -> Just BZ
        "can" -> Just CA
        "cck" -> Just CC
        "cod" -> Just CD
        "caf" -> Just CF
        "cog" -> Just CG
        "che" -> Just CH
        "civ" -> Just CI
        "cok" -> Just CK
        "chl" -> Just CL
        "cmr" -> Just CM
        "chn" -> Just CN
        "col" -> Just CO
        "cri" -> Just CR
        "cub" -> Just CU
        "cpv" -> Just CV
        "cuw" -> Just CW
        "cxr" -> Just CX
        "cyp" -> Just CY
        "cze" -> Just CZ
        "deu" -> Just DE
        "dji" -> Just DJ
        "dnk" -> Just DK
        "dma" -> Just DM
        "dom" -> Just DO
        "dza" -> Just DZ
        "ecu" -> Just EC
        "est" -> Just EE
        "egy" -> Just EG
        "esh" -> Just EH
        "eri" -> Just ER
        "esp" -> Just ES
        "eth" -> Just ET
        "fin" -> Just FI
        "fji" -> Just FJ
        "flk" -> Just FK
        "fsm" -> Just FM
        "fro" -> Just FO
        "fra" -> Just FR
        "gab" -> Just GA
        "gbr" -> Just GB
        "grd" -> Just GD
        "geo" -> Just GE
        "guf" -> Just GF
        "ggy" -> Just GG
        "gha" -> Just GH
        "gib" -> Just GI
        "grl" -> Just GL
        "gmb" -> Just GM
        "gin" -> Just GN
        "glp" -> Just GP
        "gnq" -> Just GQ
        "grc" -> Just GR
        "sgs" -> Just GS
        "gtm" -> Just GT_
        "gum" -> Just GU
        "gnb" -> Just GW
        "guy" -> Just GY
        "hkg" -> Just HK
        "hmd" -> Just HM
        "hnd" -> Just HN
        "hrv" -> Just HR
        "hti" -> Just HT
        "hun" -> Just HU
        "idn" -> Just ID
        "irl" -> Just IE
        "isr" -> Just IL
        "imn" -> Just IM
        "ind" -> Just IN
        "iot" -> Just IO
        "irq" -> Just IQ
        "irn" -> Just IR
        "isl" -> Just IS
        "ita" -> Just IT
        "jey" -> Just JE
        "jam" -> Just JM
        "jor" -> Just JO
        "jpn" -> Just JP
        "ken" -> Just KE
        "kgz" -> Just KG
        "khm" -> Just KH
        "kir" -> Just KI
        "com" -> Just KM
        "kna" -> Just KN
        "prk" -> Just KP
        "kor" -> Just KR
        "kwt" -> Just KW
        "cym" -> Just KY
        "kaz" -> Just KZ
        "lao" -> Just LA
        "lbn" -> Just LB
        "lca" -> Just LC
        "lie" -> Just LI
        "lka" -> Just LK
        "lbr" -> Just LR
        "lso" -> Just LS
        "ltu" -> Just LT_
        "lux" -> Just LU
        "lva" -> Just LV
        "lby" -> Just LY
        "mar" -> Just MA
        "mco" -> Just MC
        "mda" -> Just MD
        "mne" -> Just ME
        "maf" -> Just MF
        "mdg" -> Just MG
        "mhl" -> Just MH
        "mkd" -> Just MK
        "mli" -> Just ML
        "mmr" -> Just MM
        "mng" -> Just MN
        "mac" -> Just MO
        "mnp" -> Just MP
        "mtq" -> Just MQ
        "mrt" -> Just MR
        "msr" -> Just MS
        "mlt" -> Just MT
        "mus" -> Just MU
        "mdv" -> Just MV
        "mwi" -> Just MW
        "mex" -> Just MX
        "mys" -> Just MY
        "moz" -> Just MZ
        "nam" -> Just NA
        "ncl" -> Just NC
        "ner" -> Just NE
        "nfk" -> Just NF
        "nga" -> Just NG
        "nic" -> Just NI
        "nld" -> Just NL
        "nor" -> Just NO
        "npl" -> Just NP
        "nru" -> Just NR
        "niu" -> Just NU
        "nzl" -> Just NZ
        "omn" -> Just OM
        "pan" -> Just PA
        "per" -> Just PE
        "pyf" -> Just PF
        "png" -> Just PG
        "phl" -> Just PH
        "pak" -> Just PK
        "pol" -> Just PL
        "spm" -> Just PM
        "pcn" -> Just PN
        "pri" -> Just PR
        "pse" -> Just PS
        "prt" -> Just PT
        "plw" -> Just PW
        "pry" -> Just PY
        "qat" -> Just QA
        "reu" -> Just RE
        "rou" -> Just RO
        "srb" -> Just RS
        "rus" -> Just RU
        "rwa" -> Just RW
        "sau" -> Just SA
        "slb" -> Just SB
        "syc" -> Just SC
        "sdn" -> Just SD
        "swe" -> Just SE
        "sgp" -> Just SG
        "shn" -> Just SH
        "svn" -> Just SI
        "sjm" -> Just SJ
        "svk" -> Just SK
        "sle" -> Just SL
        "smr" -> Just SM
        "sen" -> Just SN
        "som" -> Just SO
        "sur" -> Just SR
        "ssd" -> Just SS
        "stp" -> Just ST
        "slv" -> Just SV
        "sxm" -> Just SX
        "syr" -> Just SY
        "swz" -> Just SZ
        "tca" -> Just TC
        "tcd" -> Just TD
        "atf" -> Just TF
        "tgo" -> Just TG
        "tha" -> Just TH
        "tjk" -> Just TJ
        "tkl" -> Just TK
        "tls" -> Just TL
        "tkm" -> Just TM
        "tun" -> Just TN
        "ton" -> Just TO
        "tur" -> Just TR
        "tto" -> Just TT
        "tuv" -> Just TV
        "twn" -> Just TW
        "tza" -> Just TZ
        "ukr" -> Just UA
        "uga" -> Just UG
        "umi" -> Just UM
        "usa" -> Just US
        "ury" -> Just UY
        "uzb" -> Just UZ
        "vat" -> Just VA
        "vct" -> Just VC
        "ven" -> Just VE
        "vgb" -> Just VG
        "vir" -> Just VI
        "vnm" -> Just VN
        "vut" -> Just VU
        "wlf" -> Just WF
        "wsm" -> Just WS
        "yem" -> Just YE
        "myt" -> Just YT
        "zaf" -> Just ZA
        "zmb" -> Just ZM
        "zwe" -> Just ZW
        _ -> Nothing

{-| `ISO 3166-1 numeric` code from `CountryCode`.
-}
toNumeric : CountryCode -> Int
toNumeric c =
    case c of
        AD -> 20
        AE -> 784
        AF -> 4
        AG -> 28
        AI -> 660
        AL -> 8
        AM -> 51
        AO -> 24
        AQ -> 10
        AR -> 32
        AS -> 16
        AT -> 40
        AU -> 36
        AW -> 533
        AX -> 248
        AZ -> 31
        BA -> 70
        BB -> 52
        BD -> 50
        BE -> 56
        BF -> 854
        BG -> 100
        BH -> 48
        BI -> 108
        BJ -> 204
        BL -> 652
        BM -> 60
        BN -> 96
        BO -> 68
        BQ -> 535
        BR -> 76
        BS -> 44
        BT -> 64
        BV -> 74
        BW -> 72
        BY -> 112
        BZ -> 84
        CA -> 124
        CC -> 166
        CD -> 180
        CF -> 140
        CG -> 178
        CH -> 756
        CI -> 384
        CK -> 184
        CL -> 152
        CM -> 120
        CN -> 156
        CO -> 170
        CR -> 188
        CU -> 192
        CV -> 132
        CW -> 531
        CX -> 162
        CY -> 196
        CZ -> 203
        DE -> 276
        DJ -> 262
        DK -> 208
        DM -> 212
        DO -> 214
        DZ -> 12
        EC -> 218
        EE -> 233
        EG -> 818
        EH -> 732
        ER -> 232
        ES -> 724
        ET -> 231
        FI -> 246
        FJ -> 242
        FK -> 238
        FM -> 583
        FO -> 234
        FR -> 250
        GA -> 266
        GB -> 826
        GD -> 308
        GE -> 268
        GF -> 254
        GG -> 831
        GH -> 288
        GI -> 292
        GL -> 304
        GM -> 270
        GN -> 324
        GP -> 312
        GQ -> 226
        GR -> 300
        GS -> 239
        GT_ -> 320
        GU -> 316
        GW -> 624
        GY -> 328
        HK -> 344
        HM -> 334
        HN -> 340
        HR -> 191
        HT -> 332
        HU -> 348
        ID -> 360
        IE -> 372
        IL -> 376
        IM -> 833
        IN -> 356
        IO -> 86
        IQ -> 368
        IR -> 364
        IS -> 352
        IT -> 380
        JE -> 832
        JM -> 388
        JO -> 400
        JP -> 392
        KE -> 404
        KG -> 417
        KH -> 116
        KI -> 296
        KM -> 174
        KN -> 659
        KP -> 408
        KR -> 410
        KW -> 414
        KY -> 136
        KZ -> 398
        LA -> 418
        LB -> 422
        LC -> 662
        LI -> 438
        LK -> 144
        LR -> 430
        LS -> 426
        LT_ -> 440
        LU -> 442
        LV -> 428
        LY -> 434
        MA -> 504
        MC -> 492
        MD -> 498
        ME -> 499
        MF -> 663
        MG -> 450
        MH -> 584
        MK -> 807
        ML -> 466
        MM -> 104
        MN -> 496
        MO -> 446
        MP -> 580
        MQ -> 474
        MR -> 478
        MS -> 500
        MT -> 470
        MU -> 480
        MV -> 462
        MW -> 454
        MX -> 484
        MY -> 458
        MZ -> 508
        NA -> 516
        NC -> 540
        NE -> 562
        NF -> 574
        NG -> 566
        NI -> 558
        NL -> 528
        NO -> 578
        NP -> 524
        NR -> 520
        NU -> 570
        NZ -> 554
        OM -> 512
        PA -> 591
        PE -> 604
        PF -> 258
        PG -> 598
        PH -> 608
        PK -> 586
        PL -> 616
        PM -> 666
        PN -> 612
        PR -> 630
        PS -> 275
        PT -> 620
        PW -> 585
        PY -> 600
        QA -> 634
        RE -> 638
        RO -> 642
        RS -> 688
        RU -> 643
        RW -> 646
        SA -> 682
        SB -> 90
        SC -> 690
        SD -> 729
        SE -> 752
        SG -> 702
        SH -> 654
        SI -> 705
        SJ -> 744
        SK -> 703
        SL -> 694
        SM -> 674
        SN -> 686
        SO -> 706
        SR -> 740
        SS -> 728
        ST -> 678
        SV -> 222
        SX -> 534
        SY -> 760
        SZ -> 748
        TC -> 796
        TD -> 148
        TF -> 260
        TG -> 768
        TH -> 764
        TJ -> 762
        TK -> 772
        TL -> 626
        TM -> 795
        TN -> 788
        TO -> 776
        TR -> 792
        TT -> 780
        TV -> 798
        TW -> 158
        TZ -> 834
        UA -> 804
        UG -> 800
        UM -> 581
        US -> 840
        UY -> 858
        UZ -> 860
        VA -> 336
        VC -> 670
        VE -> 862
        VG -> 92
        VI -> 850
        VN -> 704
        VU -> 548
        WF -> 876
        WS -> 882
        YE -> 887
        YT -> 175
        ZA -> 710
        ZM -> 894
        ZW -> 716

{-| `CountryCode` from `ISO 3166-1 numeric` code.
-}
fromNumeric : Int -> Maybe CountryCode
fromNumeric i =
    case i of
        20 -> Just AD
        784 -> Just AE
        4 -> Just AF
        28 -> Just AG
        660 -> Just AI
        8 -> Just AL
        51 -> Just AM
        24 -> Just AO
        10 -> Just AQ
        32 -> Just AR
        16 -> Just AS
        40 -> Just AT
        36 -> Just AU
        533 -> Just AW
        248 -> Just AX
        31 -> Just AZ
        70 -> Just BA
        52 -> Just BB
        50 -> Just BD
        56 -> Just BE
        854 -> Just BF
        100 -> Just BG
        48 -> Just BH
        108 -> Just BI
        204 -> Just BJ
        652 -> Just BL
        60 -> Just BM
        96 -> Just BN
        68 -> Just BO
        535 -> Just BQ
        76 -> Just BR
        44 -> Just BS
        64 -> Just BT
        74 -> Just BV
        72 -> Just BW
        112 -> Just BY
        84 -> Just BZ
        124 -> Just CA
        166 -> Just CC
        180 -> Just CD
        140 -> Just CF
        178 -> Just CG
        756 -> Just CH
        384 -> Just CI
        184 -> Just CK
        152 -> Just CL
        120 -> Just CM
        156 -> Just CN
        170 -> Just CO
        188 -> Just CR
        192 -> Just CU
        132 -> Just CV
        531 -> Just CW
        162 -> Just CX
        196 -> Just CY
        203 -> Just CZ
        276 -> Just DE
        262 -> Just DJ
        208 -> Just DK
        212 -> Just DM
        214 -> Just DO
        12 -> Just DZ
        218 -> Just EC
        233 -> Just EE
        818 -> Just EG
        732 -> Just EH
        232 -> Just ER
        724 -> Just ES
        231 -> Just ET
        246 -> Just FI
        242 -> Just FJ
        238 -> Just FK
        583 -> Just FM
        234 -> Just FO
        250 -> Just FR
        266 -> Just GA
        826 -> Just GB
        308 -> Just GD
        268 -> Just GE
        254 -> Just GF
        831 -> Just GG
        288 -> Just GH
        292 -> Just GI
        304 -> Just GL
        270 -> Just GM
        324 -> Just GN
        312 -> Just GP
        226 -> Just GQ
        300 -> Just GR
        239 -> Just GS
        320 -> Just GT_
        316 -> Just GU
        624 -> Just GW
        328 -> Just GY
        344 -> Just HK
        334 -> Just HM
        340 -> Just HN
        191 -> Just HR
        332 -> Just HT
        348 -> Just HU
        360 -> Just ID
        372 -> Just IE
        376 -> Just IL
        833 -> Just IM
        356 -> Just IN
        86 -> Just IO
        368 -> Just IQ
        364 -> Just IR
        352 -> Just IS
        380 -> Just IT
        832 -> Just JE
        388 -> Just JM
        400 -> Just JO
        392 -> Just JP
        404 -> Just KE
        417 -> Just KG
        116 -> Just KH
        296 -> Just KI
        174 -> Just KM
        659 -> Just KN
        408 -> Just KP
        410 -> Just KR
        414 -> Just KW
        136 -> Just KY
        398 -> Just KZ
        418 -> Just LA
        422 -> Just LB
        662 -> Just LC
        438 -> Just LI
        144 -> Just LK
        430 -> Just LR
        426 -> Just LS
        440 -> Just LT_
        442 -> Just LU
        428 -> Just LV
        434 -> Just LY
        504 -> Just MA
        492 -> Just MC
        498 -> Just MD
        499 -> Just ME
        663 -> Just MF
        450 -> Just MG
        584 -> Just MH
        807 -> Just MK
        466 -> Just ML
        104 -> Just MM
        496 -> Just MN
        446 -> Just MO
        580 -> Just MP
        474 -> Just MQ
        478 -> Just MR
        500 -> Just MS
        470 -> Just MT
        480 -> Just MU
        462 -> Just MV
        454 -> Just MW
        484 -> Just MX
        458 -> Just MY
        508 -> Just MZ
        516 -> Just NA
        540 -> Just NC
        562 -> Just NE
        574 -> Just NF
        566 -> Just NG
        558 -> Just NI
        528 -> Just NL
        578 -> Just NO
        524 -> Just NP
        520 -> Just NR
        570 -> Just NU
        554 -> Just NZ
        512 -> Just OM
        591 -> Just PA
        604 -> Just PE
        258 -> Just PF
        598 -> Just PG
        608 -> Just PH
        586 -> Just PK
        616 -> Just PL
        666 -> Just PM
        612 -> Just PN
        630 -> Just PR
        275 -> Just PS
        620 -> Just PT
        585 -> Just PW
        600 -> Just PY
        634 -> Just QA
        638 -> Just RE
        642 -> Just RO
        688 -> Just RS
        643 -> Just RU
        646 -> Just RW
        682 -> Just SA
        90 -> Just SB
        690 -> Just SC
        729 -> Just SD
        752 -> Just SE
        702 -> Just SG
        654 -> Just SH
        705 -> Just SI
        744 -> Just SJ
        703 -> Just SK
        694 -> Just SL
        674 -> Just SM
        686 -> Just SN
        706 -> Just SO
        740 -> Just SR
        728 -> Just SS
        678 -> Just ST
        222 -> Just SV
        534 -> Just SX
        760 -> Just SY
        748 -> Just SZ
        796 -> Just TC
        148 -> Just TD
        260 -> Just TF
        768 -> Just TG
        764 -> Just TH
        762 -> Just TJ
        772 -> Just TK
        626 -> Just TL
        795 -> Just TM
        788 -> Just TN
        776 -> Just TO
        792 -> Just TR
        780 -> Just TT
        798 -> Just TV
        158 -> Just TW
        834 -> Just TZ
        804 -> Just UA
        800 -> Just UG
        581 -> Just UM
        840 -> Just US
        858 -> Just UY
        860 -> Just UZ
        336 -> Just VA
        670 -> Just VC
        862 -> Just VE
        92 -> Just VG
        850 -> Just VI
        704 -> Just VN
        548 -> Just VU
        876 -> Just WF
        882 -> Just WS
        887 -> Just YE
        175 -> Just YT
        710 -> Just ZA
        894 -> Just ZM
        716 -> Just ZW
        _ -> Nothing

{-| All `CountryCode`s sorted alphabetically.
-}
all : List CountryCode
all  =
    [ AD,AE,AF,AG,AI,AL,AM,AO,AQ,AR,AS,AT,AU,AW,AX,AZ,BA,BB,BD,BE,BF,BG,BH,BI,BJ,BL,BM,BN,BO,BQ,BR,BS,BT,BV,BW,BY,BZ,CA,CC,CD,CF,CG,CH,CI,CK,CL,CM,CN,CO,CR,CU,CV,CW,CX,CY,CZ,DE,DJ,DK,DM,DO,DZ,EC,EE,EG,EH,ER,ES,ET,FI,FJ,FK,FM,FO,FR,GA,GB,GD,GE,GF,GG,GH,GI,GL,GM,GN,GP,GQ,GR,GS,GT_,GU,GW,GY,HK,HM,HN,HR,HT,HU,ID,IE,IL,IM,IN,IO,IQ,IR,IS,IT,JE,JM,JO,JP,KE,KG,KH,KI,KM,KN,KP,KR,KW,KY,KZ,LA,LB,LC,LI,LK,LR,LS,LT_,LU,LV,LY,MA,MC,MD,ME,MF,MG,MH,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,MZ,NA,NC,NE,NF,NG,NI,NL,NO,NP,NR,NU,NZ,OM,PA,PE,PF,PG,PH,PK,PL,PM,PN,PR,PS,PT,PW,PY,QA,RE,RO,RS,RU,RW,SA,SB,SC,SD,SE,SG,SH,SI,SJ,SK,SL,SM,SN,SO,SR,SS,ST,SV,SX,SY,SZ,TC,TD,TF,TG,TH,TJ,TK,TL,TM,TN,TO,TR,TT,TV,TW,TZ,UA,UG,UM,US,UY,UZ,VA,VC,VE,VG,VI,VN,VU,WF,WS,YE,YT,ZA,ZM,ZW ]